// NotificationMonitor.h
#include <windows.h>

class NotificationMonitor
{
public:
	NotificationMonitor();
	~NotificationMonitor();

	virtual void OnCardInsert() = 0;
	virtual void OnCardRemove() = 0;
	virtual void OnPowerResume() = 0;

private:
	HANDLE m_powerQueue;
	HANDLE m_storageQueue;
	HANDLE m_powerThread;
	HANDLE m_storageThread;

	static DWORD WINAPI PowerMonitorThreadProc(void *data);
	static DWORD WINAPI StorageMonitorThreadProc(void *data);

	volatile static BOOL m_stop;
};
